# coding: utf-8

"""
    Middleware

    Knowledge Graph data management.

    The version of the OpenAPI document: 1.0
    Contact: hello@wordlift.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class EntityGapRequest(BaseModel):
    """
    EntityGapRequest
    """ # noqa: E501
    url: StrictStr = Field(description="The URL to analyze.")
    query: StrictStr = Field(description="The search query to analyze.")
    model: Optional[StrictStr] = Field(default=None, description="The model")
    number_of_entities: Optional[StrictInt] = Field(default=5, description="Number of entities to highlight.")
    query_location_name: Optional[StrictStr] = Field(default='United States', description="The location name for the query, e.g. United Kingdom.")
    query_search_engine: Optional[StrictStr] = Field(default='google.com', description="The search engine domain for the query, if not set will be chosen according to `query_location_name`")
    __properties: ClassVar[List[str]] = ["url", "query", "model", "number_of_entities", "query_location_name", "query_search_engine"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EntityGapRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EntityGapRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "url": obj.get("url"),
            "query": obj.get("query"),
            "model": obj.get("model"),
            "number_of_entities": obj.get("number_of_entities") if obj.get("number_of_entities") is not None else 5,
            "query_location_name": obj.get("query_location_name") if obj.get("query_location_name") is not None else 'United States',
            "query_search_engine": obj.get("query_search_engine") if obj.get("query_search_engine") is not None else 'google.com'
        })
        return _obj


